// Test Core functions and exceptions
// $Rev: 930 $ $LastChangedDate: 2002-09-11 09:36:02 +0200 (Wed, 11 Sep 2002) $

def print_int(x) (puts(itoa(x)))
def print_float(x) (puts(ftoa(x)))

int matcher(string s)
{
	switch s {
	case "foo":
		return 1;
	case "bar":
		return 2;
	case _:
		return 3;
	}
}

void choke()
{
	<int>Slist::t foo = null;

	foo.Slist::data = 5;
}

void main()
{
	int i = atoi("12");
	float f;
	
	print_int(i);
	puts(" ");
	try {
		i = atoi("12foo");
	} with {
	case Invalid_argument(s):
		puts(String::join(s, " "));
	}

	f = atof("12.5");
	print_float(f);
	puts(" ");

	try {
		f = atof("baz12.5");
	} with {
	case Invalid_argument(s):
		puts(s + " ");
	}

	print_int(matcher("foo"));
	print_int(matcher("bar"));
	print_int(matcher("baz"));

	try {
		choke();
		puts(" ??? ");
	} with {
	case Null_access:
		puts(" NULL ");
	}
	
	puts("foo" + "bar" + "baz\n");
}

section init 
{
	main();
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 12 Core::atoi 12.5 Core::atof 123 NULL foobarbaz
 */
