/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 1048 $ $LastChangedDate: 2002-10-26 23:19:49 +0200 (Sat, 26 Oct 2002) $
 *
 * Standard library for Gont, Sys module interface.
 */

<string>Array::t argv;
<string>Array::t environ;

string getenv(string);

// (user_time, system_time)
*(int, int) times() = "Sys__times";
int clk_tck() = "Sys__clk_tck";
void dump_allocator_statistics() = "gont_alloc_dump_stats";

'a exit(int) = "Sys__exit";
'a abort() = "abort";
void at_exit(*(void ())) = "Sys__at_exit";

// execute cmd through /bin/sh -c and return exit status
int shell(string cmd) = "Sys__shell";

bool isatty(int fd) = "Sys__isatty";
